# TiXmlNode Class Reference

The parent class for everything in the Document Object Model. More...

`#include <tinyxml.h>`

Inheritance diagram for TiXmlNode:

List of all members.

## Public Types
enum | NodeType
| The types of XML nodes supported by TinyXml. More...
## Public Member Functions
const char * | Value () const
| The meaning of 'value' changes for the specific type of TiXmlNode.
const std::string & | ValueStr () const
| Return Value() as a std::string.
void | SetValue (const char *_value)
| Changes the value of the node.
void | SetValue (const std::string &_value)
| STL std::string form.
void | Clear ()
| Delete all the children of this node. Does not affect 'this'.
TiXmlNode * | Parent ()
| One step up the DOM.
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children.
const TiXmlNode * | FirstChild (const char *value) const
| The first child of this node with the matching 'value'.
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found.
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children.
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children.
const TiXmlNode * | FirstChild (const std::string &_value) const
| STL std::string form.
TiXmlNode * | FirstChild (const std::string &_value)
| STL std::string form.
const TiXmlNode * | LastChild (const std::string &_value) const
| STL std::string form.
TiXmlNode * | LastChild (const std::string &_value)
| STL std::string form.
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
| An alternate way to walk the children of a node.
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'.
const TiXmlNode * | IterateChildren (const std::string &_value, const TiXmlNode *previous) const
| STL std::string form.
TiXmlNode * | IterateChildren (const std::string &_value, const TiXmlNode *previous)
| STL std::string form.
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
| Add a new node related to this.
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
| Add a new node related to this.
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
| Replace a child of this node.
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node.
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node.
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node.
const TiXmlNode * | PreviousSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | PreviousSibling (const std::string &_value)
| STL std::string form.
const TiXmlNode * | NextSibling (const std::string &_value) const
| STL std::string form.
TiXmlNode * | NextSibling (const std::string &_value)
| STL std::string form.
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node.
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'.
const TiXmlElement * | NextSiblingElement () const
| Convenience function to get through elements.
const TiXmlElement * | NextSiblingElement (const char *) const
| Convenience function to get through elements.
const TiXmlElement * | NextSiblingElement (const std::string &_value) const
| STL std::string form.
TiXmlElement * | NextSiblingElement (const std::string &_value)
| STL std::string form.
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements.
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements.
const TiXmlElement * | FirstChildElement (const std::string &_value) const
| STL std::string form.
TiXmlElement * | FirstChildElement (const std::string &_value)
| STL std::string form.
int | Type () const
| Query the type (as an enumerated value, above) of this node.
const TiXmlDocument * | GetDocument () const
| Return a pointer to the Document this node lives in.
bool | NoChildren () const
| Returns true if this node has no children.
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type.
virtual TiXmlNode * | Clone () const =0
| Create an exact duplicate of this node and return it.
virtual bool | Accept (TiXmlVisitor *visitor) const =0
| Accept a hierchical visit the nodes in the TinyXML DOM.
## Friends
class | TiXmlDocument
class | TiXmlElement
std::istream & | operator>> (std::istream &in, TiXmlNode &base)
| An input stream operator, for every class.
std::ostream & | operator<< (std::ostream &out, const TiXmlNode &base)
| An output stream operator, for every class.
std::string & | operator<< (std::string &out, const TiXmlNode &base)
| Appends the XML node or attribute to a std::string.

## Detailed Description

The parent class for everything in the Document Object Model.

(Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

enum TiXmlNode::NodeType

The types of XML nodes supported by TinyXml.

(All the unsupported types are picked up by UNKNOWN.)

## Member Function Documentation

virtual bool TiXmlNode::Accept | ( | TiXmlVisitor * | visitor | ) | const`[pure virtual]`

Accept a hierchical visit the nodes in the TinyXML DOM.

Every node in the XML tree will be conditionally visited and the host will be called back via the TiXmlVisitor interface.

This is essentially a SAX interface for TinyXML. (Note however it doesn't re-parse the XML for the callbacks, so the performance of TinyXML is unchanged by using this interface versus any other.)

The interface has been based on ideas from:

- http://www.saxproject.org/
- http://c2.com/cgi/wiki?HierarchicalVisitorPattern

Which are both good references for "visiting".

An example of using Accept():

    		TiXmlPrinter printer;
    		tinyxmlDoc.Accept( &printer );
    		const char* xmlcstr = printer.CStr();

Implemented in TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

virtual TiXmlNode* TiXmlNode::Clone | ( |  | ) | const`[pure virtual]`

Create an exact duplicate of this node and return it.

The memory must be deleted by the caller.

Implemented in TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

const TiXmlNode* TiXmlNode::FirstChild | ( | const char * | value | ) | const

The first child of this node with the matching 'value'.

Will be null if none found.

const TiXmlDocument* TiXmlNode::GetDocument | ( |  | ) | const

Return a pointer to the Document this node lives in.

Returns null if not in a document.

TiXmlNode* TiXmlNode::InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis |
| ) |  |  |

Add a new node related to this.

Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode* TiXmlNode::InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis |
| ) |  |  |

Add a new node related to this.

Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

TiXmlNode* TiXmlNode::InsertEndChild | ( | const TiXmlNode & | addThis | ) |

Add a new node related to this.

Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

const TiXmlNode* TiXmlNode::IterateChildren | ( | const TiXmlNode * | previous | ) | const

An alternate way to walk the children of a node.

One way to iterate over nodes is:

    			for( child = parent->FirstChild(); child; child = child->NextSibling() )

IterateChildren does the same thing with the syntax:

    			child = 0;
    			while( child = parent->IterateChildren( child ) )

IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

TiXmlNode* TiXmlNode::LinkEndChild | ( | TiXmlNode * | addThis | ) |

Add a new node related to this.

Adds a child past the LastChild.

NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions.

See also:
  InsertEndChild

const TiXmlElement* TiXmlNode::NextSiblingElement | ( | const char * |  | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

const TiXmlElement* TiXmlNode::NextSiblingElement | ( |  | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlNode* TiXmlNode::ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis |
| ) |  |  |

Replace a child of this node.

Returns a pointer to the new object or NULL if an error occured.

void TiXmlNode::SetValue | ( | const char * | _value | ) | `[inline]`

Changes the value of the node.

Defined as:

    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string

Referenced by TiXmlComment::TiXmlComment(), and TiXmlText::TiXmlText().

int TiXmlNode::Type | ( |  | ) | const`[inline]`

Query the type (as an enumerated value, above) of this node.

The possible types are: TINYXML_DOCUMENT, TINYXML_ELEMENT, TINYXML_COMMENT, TINYXML_UNKNOWN, TINYXML_TEXT, and TINYXML_DECLARATION.

const char* TiXmlNode::Value | ( |  | ) | const`[inline]`

The meaning of 'value' changes for the specific type of TiXmlNode.

    		Document:	filename of the xml file
    		Element:	name of the element
    		Comment:	the comment text
    		Unknown:	the tag contents
    		Text:		the text string

The subclasses will wrap this function.

const std::string& TiXmlNode::ValueStr | ( |  | ) | const`[inline]`

Return Value() as a std::string.

If you only use STL, this is more efficient than calling Value(). Only available in STL mode.

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | out,
|  | const TiXmlNode & | base |
| ) |  |  | `[friend]`

An output stream operator, for every class.

Note that this outputs without any newlines or formatting, as opposed to Print(), which includes tabs and new lines.

The operator<< and operator>> are not completely symmetric. Writing a node to a stream is very well defined. You'll get a nice stream of output, without any extra whitespace or newlines.

But reading is not as well defined. (As it always is.) If you create a TiXmlElement (for example) and read that from an input stream, the text needs to define an element or junk will result. This is true of all input streams, but it's worth keeping in mind.

A TiXmlDocument will read nodes until it reads a root element, and all the children of that root element.

std::istream& operator>> | ( | std::istream & | in,
|  | TiXmlNode & | base |
| ) |  |  | `[friend]`

An input stream operator, for every class.

Tolerant of newlines and formatting, but doesn't expect them.

The documentation for this class was generated from the following file:

- tinyxml.h